Imports System.ComponentModel
Imports System.ComponentModel.Design
Imports System.Data.OleDb
Imports System.IO
Imports System.Runtime.Serialization


Public Class CalendarCtrl
    Private Shared configData As New ConfigDataClass

    Private m_showingMonth As DateTime
    Private m_scheduleDataList As New List(Of ScheduleDataClass)
    Private m_scheduleRepeatUnpacked As New List(Of ScheduleDataClass)

    Private m_prevMonthDays As New List(Of OneDayClass)
    Private m_showingMonthDays As New List(Of OneDayClass)
    Private m_nextMonthDays As New List(Of OneDayClass)
    Private m_memos As New List(Of MemoDataClass)

    Private m_pointMouseDown As Point

    Private Shared m_yearFont As New Font("MS UI Gothic", 20)
    Private Shared m_monthFont As New Font("MS UI Gothic", 65)

    Public Event UpdateData(ByVal sendar As Object, ByVal e As System.EventArgs)
    Public Event UpdateDayData(ByVal sendar As Object, ByVal e As System.EventArgs)
    Public Event UpdateMonth(ByVal sendar As Object, ByVal e As System.EventArgs)

    ''' <summary>
    ''' f[^XVꂽCxg𑗐M
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub SendUpdateDataEvent()
        Dim args As New System.EventArgs()
        RaiseEvent UpdateData(Me, args)
    End Sub

    ''' <summary>
    ''' I𒆂̓tXVꂽCxg𑗐M
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub SendUpdateDayDataEvent()
        Dim args As New System.EventArgs()
        RaiseEvent UpdateDayData(Me, args)
    End Sub

    ''' <summary>
    ''' XVꂽCxg𑗐M
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub SendUpdateMonthEvent()
        Dim args As New System.EventArgs()
        RaiseEvent UpdateMonth(Me, args)
    End Sub

    'ݕ\Ă錎
    Public ReadOnly Property ShowingMonth() As DateTime
        Get
            Return m_showingMonth
        End Get
        'Set(ByVal value As DateTime)
        '    m_showingMonth = value
        'End Set
    End Property

    'ݕ\̓tƂ̃f[^
    Public ReadOnly Property ShowingMonthDays() As List(Of OneDayClass)
        Get
            Return m_showingMonthDays
        End Get
    End Property

    '̌̓tƂ̃f[^
    Public ReadOnly Property NextMonthDays() As List(Of OneDayClass)
        Get
            Return m_nextMonthDays
        End Get
    End Property

    'Ǒ̓tƂ̃f[^
    Public ReadOnly Property PrevMonthDays() As List(Of OneDayClass)
        Get
            Return m_prevMonthDays
        End Get
    End Property

    'XPW[f[^
    Public ReadOnly Property ScheduleDataList() As List(Of ScheduleDataClass)
        Get
            Return m_scheduleDataList
        End Get
    End Property

    ''' <summary>
    ''' RXgN^
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub New()
        ' ̌ĂяóAWindows tH[ fUCiŕKvłB
        InitializeComponent()

        ' InitializeComponent() Ăяǒŏǉ܂B
        m_showingMonth = New DateTime(Now().Year, Now().Month, 1)
    End Sub


    ''' <summary>
    ''' Rg[[h
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CalendarCtrl_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        CreateDaysData()

        If Not Me.DesignMode Then
            If System.IO.File.Exists(configData.ImagePath(m_showingMonth.Month)) Then
                Try
                    SplitContainerImage.Panel1.BackgroundImage = Image.FromFile(configData.ImagePath(m_showingMonth.Month))
                Catch ex As Exception
                    SplitContainerImage.Panel1.BackgroundImage = Nothing
                End Try
            Else
                SplitContainerImage.Panel1.BackgroundImage = Nothing
            End If

        End If

        PrevMonthCalendarButton.CurrentDate = m_showingMonth.AddMonths(-1)
        NextMonthCalendarButton.CurrentDate = m_showingMonth.AddMonths(1)
        EditScheduleToolStripMenuItem.Enabled = False
        DelScheduleToolStripMenuItem.Enabled = False
    End Sub

    ''' <summary>
    ''' ݑIĂt擾
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetSelectedDate() As DateTime
        Dim i As Integer
        Dim nextMonth, prevMonth As New DateTime

        nextMonth = ShowingMonth.AddMonths(1)
        prevMonth = ShowingMonth.AddMonths(-1)

        For i = 1 To DateTime.DaysInMonth(ShowingMonth.Year, ShowingMonth.Month)
            If ShowingMonthDays(i).Selected Then
                Return ShowingMonthDays(i).DateOfThis
            End If
        Next

        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            If NextMonthDays(i).Selected Then
                Return NextMonthDays(i).DateOfThis
            End If
        Next

        For i = DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month) To 1 Step -1
            If PrevMonthDays(i).Selected Then
                Return PrevMonthDays(i).DateOfThis
            End If
        Next

        Return Nothing
    End Function

    ''' <summary>
    ''' J_[̗j`
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PanelYoubi_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PanelYoubi.Paint
        Dim x As Integer
        Dim widthBox As Integer = (PanelYoubi.Width - 2) / 7
        Dim heightBox As Integer = PanelYoubi.Height
        Dim youbiStr() As String = {"", "", "", "", "", "", "y"}
        Dim rect As Rectangle
        Dim youbiFont As New Font("MS UI Gothic", 9)
        Dim sf As New StringFormat()

        sf.Alignment = StringAlignment.Center

        'j\
        For x = 0 To 6
            If x = 6 Then
                rect.Width = PanelYoubi.Width - widthBox * 6 - 1
            Else
                rect.Width = widthBox
            End If

            rect.X = widthBox * x
            rect.Y = 0
            rect.Height = heightBox

            If x = 0 Then
                'j
                e.Graphics.FillRectangle(Brushes.Pink, rect)
                e.Graphics.DrawRectangle(Pens.DarkGray, rect)
                rect.Y = 7
                e.Graphics.DrawString(youbiStr(x), youbiFont, Brushes.Red, rect, sf)
            ElseIf x = 6 Then
                'yj
                e.Graphics.FillRectangle(Brushes.CornflowerBlue, rect)
                e.Graphics.DrawRectangle(Pens.DarkGray, rect)
                rect.Y = 7
                e.Graphics.DrawString(youbiStr(x), youbiFont, Brushes.Blue, rect, sf)
            Else
                '̗̑j
                e.Graphics.FillRectangle(Brushes.LightCyan, rect)
                e.Graphics.DrawRectangle(Pens.DarkGray, rect)
                rect.Y = 7
                e.Graphics.DrawString(youbiStr(x), youbiFont, Brushes.Black, rect, sf)
            End If
        Next

        youbiFont.Dispose()
        sf.Dispose()

    End Sub

    ''' <summary>
    ''' J_[̓tiCj`
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PanelCalendar_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PanelCalendar.Paint
        Dim i, x, y, width, height As Integer
        Dim widthBox As Integer = (PanelCalendar.Width - 2) / 7
        Dim heightBox As Integer = (PanelCalendar.Height - 4) / configData.DrawWeekNum

        Dim sf As New StringFormat()
        Dim nextMonth, prevMonth As New DateTime

        sf.Alignment = StringAlignment.Center

        '\錎ǍAǑ̔Nݒ
        nextMonth = m_showingMonth.AddMonths(1)
        prevMonth = m_showingMonth.AddMonths(-1)

        'Cɕ\錎̓ɂ\
        x = 0
        y = 0
        For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
            x = m_showingMonthDays(i).DateOfThis.DayOfWeek

            '؂ȂƂ̑傫
            If x = 6 Then
                width = PanelCalendar.Width - widthBox * 6 - 1
            Else
                width = widthBox
            End If
            If y = configData.DrawWeekNum - 1 Then
                height = PanelCalendar.Height - heightBox * (configData.DrawWeekNum - 1) - 1
            Else
                height = heightBox
            End If

            '`
            If x = 0 Then
                'j
                m_showingMonthDays(i).DrawOneDayAllParts(e.Graphics, Brushes.Red, Brushes.LavenderBlush, widthBox * x, heightBox * y, width, height)
            ElseIf x = 6 Then
                'yj
                m_showingMonthDays(i).DrawOneDayAllParts(e.Graphics, Brushes.Blue, Brushes.Lavender, widthBox * x, heightBox * y, width, height)
            Else
                '̗̑j
                m_showingMonthDays(i).DrawOneDayAllParts(e.Graphics, Brushes.Black, Brushes.Ivory, widthBox * x, heightBox * y, width, height)
            End If

            If x = 6 Then
                y = y + 1
                If y > configData.DrawWeekNum - 1 Then
                    Exit For
                End If
            End If
        Next

        'ɕ\錎̓ɂ\
        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            If y > configData.DrawWeekNum - 1 Then
                Exit For
            End If

            x = m_nextMonthDays(i).DateOfThis.DayOfWeek

            '؂ȂƂ̑傫
            If x = 6 Then
                width = PanelCalendar.Width - widthBox * 6 - 1
            Else
                width = widthBox
            End If
            If y = configData.DrawWeekNum - 1 Then
                height = PanelCalendar.Height - heightBox * (configData.DrawWeekNum - 1) - 1
            Else
                height = heightBox
            End If

            '`
            If x = 0 Then
                'j
                m_nextMonthDays(i).DrawOneDayAllParts(e.Graphics, Brushes.DarkRed, Brushes.Thistle, widthBox * x, heightBox * y, width, height)
            ElseIf x = 6 Then
                'yj
                m_nextMonthDays(i).DrawOneDayAllParts(e.Graphics, Brushes.DarkBlue, Brushes.LightSteelBlue, widthBox * x, heightBox * y, width, height)
            Else
                '̗̑j
                m_nextMonthDays(i).DrawOneDayAllParts(e.Graphics, Brushes.Gray, Brushes.LightGray, widthBox * x, heightBox * y, width, height)
            End If

            If x = 6 Then
                y = y + 1
                If y > configData.DrawWeekNum - 1 Then
                    Exit For
                End If
            End If
        Next

        'Oɕ\錎̓ɂ\
        y = 0
        For i = DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month) To 1 Step -1
            x = m_prevMonthDays(i).DateOfThis.DayOfWeek

            '؂ȂƂ̑傫
            If x = 6 Then
                width = PanelYoubi.Width - widthBox * 6 - 1
            Else
                width = widthBox
            End If

            If x = 6 Then
                Exit For
            End If

            '`
            If x = 0 Then
                'j
                m_prevMonthDays(i).DrawOneDayAllParts(e.Graphics, Brushes.DarkRed, Brushes.Thistle, widthBox * x, heightBox * y, width, heightBox)
            ElseIf x = 6 Then
                'yj
                m_prevMonthDays(i).DrawOneDayAllParts(e.Graphics, Brushes.DarkBlue, Brushes.LightSteelBlue, widthBox * x, heightBox * y, width, heightBox)
            Else
                '̗̑j
                m_prevMonthDays(i).DrawOneDayAllParts(e.Graphics, Brushes.Gray, Brushes.LightGray, widthBox * x, heightBox * y, width, heightBox)
            End If

            If x = 0 Then
                Exit For
            End If
        Next

        sf.Dispose()
    End Sub

    ''' <summary>
    ''' eɂɑΉf[^쐬
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub CreateDaysData()
        Dim nextMonth, prevMonth As New DateTime
        Dim i As Integer

        SplitContainerImage.Panel2.SuspendLayout()
        '\錎ǍAǑ̔Nݒ
        nextMonth = m_showingMonth.AddMonths(1)
        prevMonth = m_showingMonth.AddMonths(-1)

        'f[^NA
        m_showingMonthDays.Clear()
        m_nextMonthDays.Clear()
        m_prevMonthDays.Clear()

        '擪̓_~[
        m_showingMonthDays.Add(New OneDayClass())
        m_nextMonthDays.Add(New OneDayClass())
        m_prevMonthDays.Add(New OneDayClass())

        'Cɕ\錎̂PƂ̃f[^쐬
        For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
            m_showingMonthDays.Add(New OneDayClass(New DateTime(m_showingMonth.Year, m_showingMonth.Month, i), configData))
        Next

        'ɕ\錎̂PƂ̃f[^쐬
        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            m_nextMonthDays.Add(New OneDayClass(New DateTime(nextMonth.Year, nextMonth.Month, i), configData))
        Next

        'Oɕ\錎̂PƂ̃f[^쐬
        For i = 1 To DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month)
            m_prevMonthDays.Add(New OneDayClass(New DateTime(prevMonth.Year, prevMonth.Month, i), configData))
        Next

        SplitContainerImage.Panel2.ResumeLayout()
    End Sub

    ''' <summary>
    ''' N\ʒu擾
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function GetYearTextRect()
        Dim yearRect As Rectangle

        yearRect.X = m_monthFont.Height * 0.3 * 2 + 58
        yearRect.Y = 95 - m_yearFont.Height - 12
        yearRect.Width = m_yearFont.Height * 0.6 * 4
        yearRect.Height = m_yearFont.Height + 10

        GetYearTextRect = yearRect
    End Function


    ''' <summary>
    ''' J_[㕔̃C[W\ɔNƌ`
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub SplitContainerImage_Panel1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles SplitContainerImage.Panel1.Paint
        Dim sf As New StringFormat()
        Dim rect, yearRect As Rectangle

        sf.Alignment = StringAlignment.Center

        '̕\
        rect.X = -15
        rect.Y = 5
        rect.Width = m_monthFont.Height * 1.5
        rect.Height = m_monthFont.Height
        e.Graphics.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAlias
        e.Graphics.DrawString(m_showingMonth.Month.ToString, m_monthFont, Brushes.White, rect, sf)

        sf.Alignment = StringAlignment.Near

        'N̕\
        yearRect = GetYearTextRect()
        e.Graphics.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAlias
        e.Graphics.DrawString(m_showingMonth.Year.ToString, m_yearFont, Brushes.White, yearRect, sf)

        NextYearArrowButton.Left = yearRect.Right + 2
        PrevYearArrowButton.Left = yearRect.Left - PrevYearArrowButton.Width - 3

        sf.Dispose()
    End Sub

    ''' <summary>
    ''' XPW[ǉEҏW_CAO̕\
    ''' </summary>
    ''' <param name="selectedDate">lƂė^t</param>
    ''' <param name="schedule">ҏW̏ꍇAI𒆂̃XPW[</param>
    ''' <remarks></remarks>
    Public Sub ShowEditScheduleDlg(Optional ByVal selectedDate As DateTime = Nothing, Optional ByRef schedule As ScheduleDataClass = Nothing)

        Dim sdBuf As New ScheduleDataClass()
        Dim EditScheduleDlg As New EditScheduleForm()

        Try
            'ҏW̏ꍇ
            If schedule IsNot Nothing Then
                EditScheduleDlg.StartDateTimePicker.Value = schedule.StartDateTime
                EditScheduleDlg.EndDateTimePicker.Value = schedule.EndDateTime
                EditScheduleDlg.TitleTextBox.Text = schedule.Title
                EditScheduleDlg.StartTimeComboBox.Text = schedule.StartDateTime.ToString("HH:mm")
                EditScheduleDlg.EndTimeComboBox.Text = schedule.EndDateTime.ToString("HH:mm")
                EditScheduleDlg.PlaceTextBox.Text = schedule.Place
                EditScheduleDlg.MemoTextBox.Text = schedule.Memo

                EditScheduleDlg.RepeatType = schedule.RepeatType
                EditScheduleDlg.RepeatEndDateTimePicker.Value = schedule.RepeatEndDateTime

                sdBuf.Copy(schedule)

            Else
                'lƂĐݒ肷t
                If Not selectedDate.Equals(Nothing) Then
                    EditScheduleDlg.StartDateTimePicker.Value = selectedDate
                    EditScheduleDlg.EndDateTimePicker.Value = selectedDate
                    EditScheduleDlg.RepeatEndDateTimePicker.Value = selectedDate
                End If
            End If

        Catch ex As Exception
        End Try

        'XPW[ǉ_CAO̕\
        If EditScheduleDlg.ShowDialog() = System.Windows.Forms.DialogResult.OK Then

            sdBuf.Title = EditScheduleDlg.TitleTextBox.Text
            sdBuf.StartDateTime = EditScheduleDlg.StartDateTime
            sdBuf.EndDateTime = EditScheduleDlg.EndDateTime
            sdBuf.Place = EditScheduleDlg.PlaceTextBox.Text
            sdBuf.Memo = EditScheduleDlg.MemoTextBox.Text

            sdBuf.RepeatType = EditScheduleDlg.RepeatType
            sdBuf.RepeatEndDateTime = EditScheduleDlg.RepeatEndDateTimePicker.Value

            If schedule IsNot Nothing Then
                'ҏW
                schedule.Copy(sdBuf)
            Else
                'ǉ
                sdBuf.InputDateTime = Now

                'f[^Xg֒ǉ
                m_scheduleDataList.Add(sdBuf)
                m_scheduleDataList.Sort()
            End If

            'eɃf[^WJ
            ArrageSchedulesToDayData()

            Me.Refresh()
            SendUpdateDataEvent()
            SendUpdateDayDataEvent()
        End If

        EditScheduleDlg.Dispose()
        sdBuf = Nothing
    End Sub

    ''' <summary>
    ''' XPW[f[^̃XgAeɂƂɓWJ
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ArrageSchedulesToDayData()
        Dim i, rowBuf, rowBufLong, addCount As Integer
        Dim nextMonth, prevMonth As New DateTime
        Dim repeatDateBuf1, repeatDateBuf2 As DateTime

        nextMonth = m_showingMonth.AddMonths(1)
        prevMonth = m_showingMonth.AddMonths(-1)

        'f[^NA
        For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
            m_showingMonthDays(i).ClearSchedules()
        Next
        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            m_nextMonthDays(i).ClearSchedules()
        Next
        For i = 1 To DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month)
            m_prevMonthDays(i).ClearSchedules()
        Next

        's[gXPW[̓WJ
        m_scheduleRepeatUnpacked.Clear()
        For Each scheduleData As ScheduleDataClass In m_scheduleDataList

            'ʏXPW[͂̂܂ܓo^
            If scheduleData.RepeatType = ScheduleDataClass.RepeatTypePattern.None Then
                m_scheduleRepeatUnpacked.Add(New ScheduleDataClass(scheduleData))
                m_scheduleRepeatUnpacked(m_scheduleRepeatUnpacked.Count - 1).BaseSchedule = scheduleData

                'JԂXPW[
            ElseIf (scheduleData.RepeatType = ScheduleDataClass.RepeatTypePattern.daily) Or _
                    (scheduleData.RepeatType = ScheduleDataClass.RepeatTypePattern.weekly) Or _
                    (scheduleData.RepeatType = ScheduleDataClass.RepeatTypePattern.monthly) Then

                repeatDateBuf1 = scheduleData.StartDateTime
                repeatDateBuf2 = scheduleData.EndDateTime

                addCount = 1
                While repeatDateBuf1 <= scheduleData.RepeatEndDateTime
                    m_scheduleRepeatUnpacked.Add(New ScheduleDataClass(scheduleData))
                    m_scheduleRepeatUnpacked(m_scheduleRepeatUnpacked.Count - 1).BaseSchedule = scheduleData
                    m_scheduleRepeatUnpacked(m_scheduleRepeatUnpacked.Count - 1).StartDateTime = repeatDateBuf1
                    m_scheduleRepeatUnpacked(m_scheduleRepeatUnpacked.Count - 1).EndDateTime = repeatDateBuf2

                    If scheduleData.RepeatType = ScheduleDataClass.RepeatTypePattern.daily Then
                        repeatDateBuf1 = scheduleData.StartDateTime.AddDays(addCount)
                        repeatDateBuf2 = scheduleData.EndDateTime.AddDays(addCount)
                    ElseIf scheduleData.RepeatType = ScheduleDataClass.RepeatTypePattern.weekly Then
                        repeatDateBuf1 = scheduleData.StartDateTime.AddDays(7 * addCount)
                        repeatDateBuf2 = scheduleData.EndDateTime.AddDays(7 * addCount)
                    ElseIf scheduleData.RepeatType = ScheduleDataClass.RepeatTypePattern.monthly Then
                        repeatDateBuf1 = scheduleData.StartDateTime.AddMonths(addCount)
                        repeatDateBuf2 = scheduleData.EndDateTime.AddMonths(addCount)
                    End If

                    addCount += 1
                End While

            End If

        Next

        m_scheduleRepeatUnpacked.Sort()

        'XPW[etƂɓo^
        For Each scheduleData As ScheduleDataClass In m_scheduleRepeatUnpacked
            rowBuf = 0
            rowBufLong = 0
            '挎
            For i = 1 To DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month)
                m_prevMonthDays(i).RegisterSchedules(scheduleData, rowBuf, rowBufLong)
            Next
            '
            For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
                If m_showingMonthDays(i).DateOfThis.Day = 1 Then
                    m_showingMonthDays(i).RegisterSchedules(scheduleData, rowBuf, rowBufLong, True)
                Else
                    m_showingMonthDays(i).RegisterSchedules(scheduleData, rowBuf, rowBufLong)

                End If
            Next
            '
            For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
                m_nextMonthDays(i).RegisterSchedules(scheduleData, rowBuf, rowBufLong)
            Next
        Next

        'etƂɓo^
        For Each memoData As MemoDataClass In m_memos
            rowBuf = 0
            rowBufLong = 0
            '挎
            For i = 1 To DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month)
                If m_prevMonthDays(i).DateOfThis = memoData.DateOfThis Then
                    m_prevMonthDays(i).Memo = New MemoDataClass(memoData)
                    m_prevMonthDays(i).Memo.BaseMemo = memoData
                End If
            Next
            '
            For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
                If m_showingMonthDays(i).DateOfThis = memoData.DateOfThis Then
                    m_showingMonthDays(i).Memo = New MemoDataClass(memoData)
                    m_showingMonthDays(i).Memo.BaseMemo = memoData
                End If
            Next
            '
            For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
                If m_nextMonthDays(i).DateOfThis = memoData.DateOfThis Then
                    m_nextMonthDays(i).Memo = New MemoDataClass(memoData)
                    m_nextMonthDays(i).Memo.BaseMemo = memoData
                End If
            Next
        Next

    End Sub

    ''' <summary>
    ''' J_[ł̃}EX_uNbN
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PanelCalendar_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PanelCalendar.MouseDoubleClick
        If Not EditSchedule() Then
            AddSchedule()
        End If

    End Sub

    ''' <summary>
    ''' J_[ł̃}EXNbN
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PanelCalendar_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PanelCalendar.MouseClick
        Dim i As Integer
        Dim nextMonth, prevMonth As New DateTime

        Me.Focus()

        nextMonth = m_showingMonth.AddMonths(1)
        prevMonth = m_showingMonth.AddMonths(-1)

        'INA
        For Each scheduleData As ScheduleDataClass In m_scheduleDataList
            If scheduleData.Selected Then
                scheduleData.Redraw = True
                scheduleData.Selected = False
            End If
        Next

        't̑I`FbN
        For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
            m_showingMonthDays(i).CheckSelectDate(e.X, e.Y, PanelCalendar)
            'XPW[̑I
            m_showingMonthDays(i).CheckSelectSchedule(e.X, e.Y, PanelCalendar)
        Next

        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            m_nextMonthDays(i).CheckSelectDate(e.X, e.Y, PanelCalendar)
            'XPW[̑I
            m_nextMonthDays(i).CheckSelectSchedule(e.X, e.Y, PanelCalendar)
        Next

        For i = DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month) To 1 Step -1
            m_prevMonthDays(i).CheckSelectDate(e.X, e.Y, PanelCalendar)
            'XPW[̑I
            m_prevMonthDays(i).CheckSelectSchedule(e.X, e.Y, PanelCalendar)
        Next

        'XVCxg
        For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
            If m_showingMonthDays(i).Selected Then
                ''Xgr[XV
                SendUpdateDayDataEvent()
            End If
        Next

        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            If m_nextMonthDays(i).Selected Then
                ''Xgr[XV
                SendUpdateDayDataEvent()
            End If
        Next

        For i = DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month) To 1 Step -1
            If m_prevMonthDays(i).Selected Then
                ''Xgr[XV
                SendUpdateDayDataEvent()
            End If
        Next

        'ĕ`
        RedrawSchedules()
    End Sub

    ''' <summary>
    ''' XPW[ĕ`
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub RedrawSchedules()
        Dim i As Integer
        Dim nextMonth, prevMonth As New DateTime

        nextMonth = m_showingMonth.AddMonths(1)
        prevMonth = m_showingMonth.AddMonths(-1)

        'ĕ`̈ݒ
        For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
            'ĕ`
            m_showingMonthDays(i).InvalidateScheduleArea(PanelCalendar)
        Next

        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            'ĕ`
            m_nextMonthDays(i).InvalidateScheduleArea(PanelCalendar)
        Next

        For i = DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month) To 1 Step -1
            'ĕ`
            m_prevMonthDays(i).InvalidateScheduleArea(PanelCalendar)
        Next

        PanelCalendar.Update()

        'ĕ`tONA
        For Each scheduleData As ScheduleDataClass In m_scheduleDataList
            scheduleData.Redraw = False
        Next

    End Sub

    ''' <summary>
    ''' \錎ړ
    ''' </summary>
    ''' <param name="months">ړ邩i}CiXj</param>
    ''' <param name="go1day">̌̏I邩ǂ</param>
    ''' <remarks></remarks>
    Public Sub GoNextMonth(Optional ByVal months As Integer = 1, Optional ByVal go1day As Boolean = True)
        RegisterMemoToMemory()
        m_showingMonth = m_showingMonth.AddMonths(months)

        If (m_showingMonth.Year < 1753) Or (m_showingMonth.Year > 9998) Then
            m_showingMonth = m_showingMonth.AddMonths(-months)
            Exit Sub
        End If

        If go1day Then
            SelectDate(New DateTime(ShowingMonth.Year, ShowingMonth.Month, 1))
        Else
            SelectDate(GetSelectedDate())
        End If
    End Sub

    ''' <summary>
    ''' ̌{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub NextMonthCalendarButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextMonthCalendarButton.Click
        GoNextMonth(1)
    End Sub

    ''' <summary>
    ''' Ǒ{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PrevMonthCalendarButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevMonthCalendarButton.Click
        GoNextMonth(-1)
    End Sub

    ''' <summary>
    ''' ̌{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub NextMonthArrowButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextMonthArrowButton.Click
        GoNextMonth()
    End Sub

    ''' <summary>
    ''' Ǒ{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PrevMonthArrowButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevMonthArrowButton.Click
        GoNextMonth(-1)
    End Sub

    ''' <summary>
    ''' ̔N{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub NextYearArrowButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextYearArrowButton.Click
        GoNextMonth(12)
    End Sub

    ''' <summary>
    ''' O̔N{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PrevYearArrowButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevYearArrowButton.Click
        GoNextMonth(-12)
    End Sub

    ''' <summary>
    ''' TCY̏
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub SplitContainerImage_Panel1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles SplitContainerImage.Panel1.Resize
        Dim yearRect As Rectangle = GetYearTextRect()

        NextMonthCalendarButton.Left = SplitContainerImage.Panel1.ClientSize.Width - NextMonthCalendarButton.Width - 20
        PrevMonthCalendarButton.Left = NextMonthCalendarButton.Left - NextMonthCalendarButton.Width - 3

        NextMonthArrowButton.Left = NextMonthCalendarButton.Right + 2
        PrevMonthArrowButton.Left = PrevMonthCalendarButton.Left - PrevMonthArrowButton.Width - 2
    End Sub

    ''' <summary>
    ''' XPW[̒ǉ
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub AddSchedule()
        Dim i As Integer
        Dim nextMonth, prevMonth As New DateTime

        nextMonth = m_showingMonth.AddMonths(1)
        prevMonth = m_showingMonth.AddMonths(-1)

        For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
            '_CAO\
            If m_showingMonthDays(i).Selected Then
                ShowEditScheduleDlg(m_showingMonthDays(i).DateOfThis)
                Exit Sub
            End If
        Next

        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            '_CAO\
            If m_nextMonthDays(i).Selected Then
                ShowEditScheduleDlg(m_nextMonthDays(i).DateOfThis)
                Exit Sub
            End If
        Next

        For i = DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month) To 1 Step -1
            '_CAO\
            If m_prevMonthDays(i).Selected Then
                ShowEditScheduleDlg(m_prevMonthDays(i).DateOfThis)
                Exit Sub
            End If
        Next

        ShowEditScheduleDlg()

    End Sub

    ''' <summary>
    ''' XPW[̕ҏW
    ''' </summary>
    ''' <param name="showDlg">XPW[̕ҏW_CAO\邩ǂ</param>
    ''' <returns>I𒆂̃XPW[邩ǂԂ</returns>
    ''' <remarks></remarks>
    Public Function EditSchedule(Optional ByVal showDlg As Boolean = True) As Boolean
        Dim i As Integer
        Dim nextMonth, prevMonth As New DateTime

        nextMonth = m_showingMonth.AddMonths(1)
        prevMonth = m_showingMonth.AddMonths(-1)

        For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
            For Each scheduleData As ScheduleDataClass In m_showingMonthDays(i).ScheduleData
                If scheduleData.IsValid Then
                    If scheduleData.BaseSchedule.Selected Then
                        '_CAO\
                        If showDlg Then
                            ShowEditScheduleDlg(, scheduleData.BaseSchedule)
                        End If
                        Return True
                    End If

                End If
            Next
        Next

        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            '_CAO\
            For Each scheduleData As ScheduleDataClass In m_nextMonthDays(i).ScheduleData
                If scheduleData.IsValid Then
                    If scheduleData.BaseSchedule.Selected Then
                        '_CAO\
                        If showDlg Then
                            ShowEditScheduleDlg(, scheduleData.BaseSchedule)
                        End If
                        Return True
                    End If

                End If
            Next

        Next

        For i = DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month) To 1 Step -1
            '_CAO\
            For Each scheduleData As ScheduleDataClass In m_prevMonthDays(i).ScheduleData
                If scheduleData.IsValid Then
                    If scheduleData.BaseSchedule.Selected Then
                        '_CAO\
                        If showDlg Then
                            ShowEditScheduleDlg(, scheduleData.BaseSchedule)
                        End If
                        Return True
                    End If

                End If
            Next
        Next

        Return False
    End Function

    ''' <summary>
    ''' XPW[̍폜
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub DeleteSchedule()
        Dim i As Integer
        Dim nextMonth, prevMonth As New DateTime

        nextMonth = m_showingMonth.AddMonths(1)
        prevMonth = m_showingMonth.AddMonths(-1)

        For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
            For Each scheduleData As ScheduleDataClass In m_showingMonthDays(i).ScheduleData
                If scheduleData.IsValid Then
                    If scheduleData.BaseSchedule.Selected Then
                        scheduleData.BaseSchedule.IsValid = False
                        ArrageSchedulesToDayData()
                        Me.Refresh()
                        SendUpdateDataEvent()
                        SendUpdateDayDataEvent()
                        Exit Sub
                    End If

                End If
            Next
        Next

        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            For Each scheduleData As ScheduleDataClass In m_nextMonthDays(i).ScheduleData
                If scheduleData.IsValid Then
                    If scheduleData.BaseSchedule.Selected Then
                        scheduleData.BaseSchedule.IsValid = False
                        ArrageSchedulesToDayData()
                        Me.Refresh()
                        SendUpdateDataEvent()
                        SendUpdateDayDataEvent()
                        Exit Sub
                    End If

                End If
            Next

        Next

        For i = DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month) To 1 Step -1
            For Each scheduleData As ScheduleDataClass In m_prevMonthDays(i).ScheduleData
                If scheduleData.IsValid Then
                    If scheduleData.BaseSchedule.Selected Then
                        scheduleData.BaseSchedule.IsValid = False
                        ArrageSchedulesToDayData()
                        Me.Refresh()
                        SendUpdateDataEvent()
                        SendUpdateDayDataEvent()
                        Exit Sub
                    End If

                End If
            Next
        Next


    End Sub

    ''' <summary>
    ''' vr[\
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub PrintScheduleCalendar()
        PrintDocument1.OriginAtMargins = True
        PrintDocument1.DefaultPageSettings.Margins.Left = 100
        PrintDocument1.DefaultPageSettings.Margins.Top = 150
        PrintDocument1.DefaultPageSettings.Margins.Right = 100
        PrintDocument1.DefaultPageSettings.Margins.Bottom = 150

        Dim ppd As New PrintPreviewDialog
        ppd.Document = PrintDocument1
        ppd.StartPosition = FormStartPosition.Manual
        ppd.SetBounds(150, 50, 400, 550)
        ppd.PrintPreviewControl.Zoom = 1
        ppd.ShowDialog()


    End Sub

    ''' <summary>
    ''' ܂̓fXNgbvǎp̃J_[`
    ''' </summary>
    ''' <param name="gr"></param>
    ''' <param name="targetRect"></param>
    ''' <param name="youbiFont"></param>
    ''' <param name="fillBackground"></param>
    ''' <param name="backRect"></param>
    ''' <remarks></remarks>
    Private Sub DrawSchedulesForImage(ByVal gr As Graphics, ByVal targetRect As Rectangle, ByVal youbiFont As Font, ByVal fillBackground As Boolean, ByVal backRect As Rectangle)
        Dim x As Integer
        Dim widthBox As Integer = (targetRect.Width - 2) / 7
        Dim heightBox As Integer = targetRect.Height / 20
        Dim youbiStr() As String = {"", "", "", "", "", "", "y"}
        Dim rect As Rectangle
        Dim sf As New StringFormat()
        Dim monthFont As New Font("MS UI Gothic", 22)
        Dim monthHeight As Integer

        sf.Alignment = StringAlignment.Center

        'wi
        If fillBackground Then
            gr.FillRectangle(Brushes.White, backRect.Left, backRect.Top, backRect.Width, backRect.Height)
        End If

        'N\
        rect.Width = targetRect.Width
        rect.X = targetRect.Left
        rect.Y = targetRect.Top
        rect.Height = monthFont.Height + 2
        monthHeight = rect.Height
        gr.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAlias
        gr.DrawString(m_showingMonth.ToString("yyyyNM"), monthFont, Brushes.Black, rect)
        gr.TextRenderingHint = Drawing.Text.TextRenderingHint.SystemDefault

        'j\
        For x = 0 To 6
            rect.Width = widthBox
            rect.X = widthBox * x + targetRect.Left
            rect.Y = targetRect.Top + monthHeight
            rect.Height = heightBox

            If x = 0 Then
                'j
                gr.DrawRectangle(Pens.Black, rect)
                rect.Y = heightBox - youbiFont.Height - 2 + targetRect.Top + monthHeight
                gr.DrawString(youbiStr(x), youbiFont, Brushes.Red, rect, sf)
            ElseIf x = 6 Then
                'yj
                gr.DrawRectangle(Pens.Black, rect)
                rect.Y = heightBox - youbiFont.Height - 2 + targetRect.Top + monthHeight
                gr.DrawString(youbiStr(x), youbiFont, Brushes.Blue, rect, sf)
            Else
                '̗̑j
                gr.DrawRectangle(Pens.Black, rect)
                rect.Y = heightBox - youbiFont.Height - 2 + targetRect.Top + monthHeight
                gr.DrawString(youbiStr(x), youbiFont, Brushes.Black, rect, sf)
            End If
        Next


        't-----------------------------------
        Dim i, y, width, height, youbiHeight As Integer
        Dim nextMonth, prevMonth As New DateTime

        youbiHeight = heightBox + +monthHeight
        heightBox = (targetRect.Height - youbiHeight) / configData.DrawWeekNum

        '\錎ǍAǑ̔Nݒ
        nextMonth = m_showingMonth.AddMonths(1)
        prevMonth = m_showingMonth.AddMonths(-1)

        'Cɕ\錎̓ɂ\
        x = 0
        y = 0
        For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
            x = m_showingMonthDays(i).DateOfThis.DayOfWeek

            width = widthBox
            height = heightBox

            '`
            If x = 0 Then
                'j
                m_showingMonthDays(i).DrawOneDayAllParts(gr, Brushes.Red, Brushes.LavenderBlush, widthBox * x + targetRect.Left, heightBox * y + youbiHeight + targetRect.Top, width, height, True)
            ElseIf x = 6 Then
                'yj
                m_showingMonthDays(i).DrawOneDayAllParts(gr, Brushes.Blue, Brushes.Lavender, widthBox * x + targetRect.Left, heightBox * y + youbiHeight + targetRect.Top, width, height, True)
            Else
                '̗̑j
                m_showingMonthDays(i).DrawOneDayAllParts(gr, Brushes.Black, Brushes.Ivory, widthBox * x + targetRect.Left, heightBox * y + youbiHeight + targetRect.Top, width, height, True)
            End If

            If x = 6 Then
                y = y + 1
                If y > configData.DrawWeekNum - 1 Then
                    Exit For
                End If
            End If
        Next

        'ɕ\錎̓ɂ\
        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            If y > configData.DrawWeekNum - 1 Then
                Exit For
            End If

            x = m_nextMonthDays(i).DateOfThis.DayOfWeek

            width = widthBox
            height = heightBox


            '`
            If x = 0 Then
                'j
                m_nextMonthDays(i).DrawOneDayAllParts(gr, Brushes.DarkRed, Brushes.Thistle, widthBox * x + targetRect.Left, heightBox * y + youbiHeight + targetRect.Top, width, height, True)
            ElseIf x = 6 Then
                'yj
                m_nextMonthDays(i).DrawOneDayAllParts(gr, Brushes.DarkBlue, Brushes.LightSteelBlue, widthBox * x + targetRect.Left, heightBox * y + youbiHeight + targetRect.Top, width, height, True)
            Else
                '̗̑j
                m_nextMonthDays(i).DrawOneDayAllParts(gr, Brushes.Gray, Brushes.LightGray, widthBox * x + targetRect.Left, heightBox * y + youbiHeight + targetRect.Top, width, height, True)
            End If

            If x = 6 Then
                y = y + 1
                If y > configData.DrawWeekNum - 1 Then
                    Exit For
                End If
            End If
        Next

        'Oɕ\錎̓ɂ\
        y = 0
        For i = DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month) To 1 Step -1
            x = m_prevMonthDays(i).DateOfThis.DayOfWeek

            width = widthBox
            height = heightBox

            '`
            If x = 0 Then
                'j
                m_prevMonthDays(i).DrawOneDayAllParts(gr, Brushes.DarkRed, Brushes.Thistle, widthBox * x + targetRect.Left, heightBox * y + youbiHeight + targetRect.Top, width, height, True)
            ElseIf x = 6 Then
                'yj
                m_prevMonthDays(i).DrawOneDayAllParts(gr, Brushes.DarkBlue, Brushes.LightSteelBlue, widthBox * x + targetRect.Left, heightBox * y + youbiHeight + targetRect.Top, width, height, True)
            Else
                '̗̑j
                m_prevMonthDays(i).DrawOneDayAllParts(gr, Brushes.Gray, Brushes.LightGray, widthBox * x + targetRect.Left, heightBox * y + youbiHeight + targetRect.Top, width, height, True)
            End If

            If x = 0 Then
                Exit For
            End If
        Next

        youbiFont.Dispose()
        sf.Dispose()
    End Sub

    ''' <summary>
    ''' nh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage

        DrawSchedulesForImage(e.Graphics, New Rectangle(0, 0, e.MarginBounds.Width, e.MarginBounds.Height), _
            New Font("MS UI Gothic", 14), False, New Rectangle(0, 0, 0, 0))

    End Sub

    ''' <summary>
    ''' DBփXPW[
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub SaveScheduleData()
        Const strInsertSchedule As String = "INSERT INTO Schedules " & _
      "(StartDateTime, EndDateTime, InputDateTime, Title, Place, MemoData, RepeatStartDate,RepeatEndDate, RepeatType, ValidData) " & _
      "VALUES(@startDateTime, @endDateTime, @inputDateTime, @title, @place, @memoData, @repeatStartDate, @repeatEndDate, @repeatType, @validData)"

        Const strDeleteSchedule As String = "DELETE * FROM Schedules"
        Const strInsertMemo As String = "INSERT INTO Memos (DateData, MemoData) VALUES(@dateData, @memoData)"
        Const strDeleteMemo As String = "DELETE * FROM Memos"

        Dim oConn As New OleDbConnection()
        Dim oCommandSchedule, oCommandMemo As New OleDbCommand()

        Try
            oConn = New OleDbConnection()
            oConn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & _
            Application.StartupPath + "\Scheduler.mdb"
            oCommandSchedule.Connection = oConn

            'caڑJ
            oConn.Open()

            'SQL̐ݒ
            'NA
            oCommandSchedule.CommandText = strDeleteSchedule
            oCommandSchedule.ExecuteNonQuery()

            'CT[g
            oCommandSchedule.CommandText = strInsertSchedule

            'p[^̐ݒ
            oCommandSchedule.Parameters.Add(New OleDbParameter("@startDateTime", OleDbType.DBTimeStamp))
            oCommandSchedule.Parameters.Add(New OleDbParameter("@endDateTime", OleDbType.DBTimeStamp))
            oCommandSchedule.Parameters.Add(New OleDbParameter("@inputDateTime", OleDbType.DBTimeStamp))
            oCommandSchedule.Parameters.Add(New OleDbParameter("@title", OleDbType.Char, 255))
            oCommandSchedule.Parameters.Add(New OleDbParameter("@place", OleDbType.Char, 255))
            oCommandSchedule.Parameters.Add(New OleDbParameter("@memoData", OleDbType.Char, 255))
            oCommandSchedule.Parameters.Add(New OleDbParameter("@repeatStartDate", OleDbType.DBTimeStamp))
            oCommandSchedule.Parameters.Add(New OleDbParameter("@repeatEndDate", OleDbType.DBTimeStamp))
            oCommandSchedule.Parameters.Add(New OleDbParameter("@repeatType", OleDbType.Integer))
            oCommandSchedule.Parameters.Add(New OleDbParameter("@validData", OleDbType.Boolean))

            For Each scheduleData As ScheduleDataClass In m_scheduleDataList
                If scheduleData.IsValid Then
                    oCommandSchedule.Parameters("@startDateTime").Value = scheduleData.StartDateTime
                    oCommandSchedule.Parameters("@endDateTime").Value = scheduleData.EndDateTime
                    oCommandSchedule.Parameters("@inputDateTime").Value = scheduleData.InputDateTime
                    oCommandSchedule.Parameters("@title").Value = scheduleData.Title

                    oCommandSchedule.Parameters("@place").Value = scheduleData.Place
                    oCommandSchedule.Parameters("@memoData").Value = scheduleData.Memo.ToString
                    oCommandSchedule.Parameters("@repeatStartDate").Value = scheduleData.RepeatStartDateTime
                    oCommandSchedule.Parameters("@repeatEndDate").Value = scheduleData.RepeatEndDateTime
                    oCommandSchedule.Parameters("@repeatType").Value = scheduleData.RepeatType
                    oCommandSchedule.Parameters("@validData").Value = scheduleData.IsValid

                    oCommandSchedule.ExecuteNonQuery()
                End If
            Next

            'f[^
            oCommandMemo.Connection = oConn
            'NA
            oCommandMemo.CommandText = strDeleteMemo
            oCommandMemo.ExecuteNonQuery()

            'CT[g
            oCommandMemo.CommandText = strInsertMemo

            oCommandMemo.Parameters.Add(New OleDbParameter("@dateData", OleDbType.DBTimeStamp))
            oCommandMemo.Parameters.Add(New OleDbParameter("@memoData", OleDbType.Char, 255))

            For Each memoData As MemoDataClass In m_memos
                If memoData.IsValid Then
                    oCommandMemo.Parameters("@dateData").Value = memoData.DateOfThis
                    oCommandMemo.Parameters("@memoData").Value = memoData.Text.ToString
                    oCommandMemo.ExecuteNonQuery()
                End If
            Next

        Catch oExcept As Exception
            MessageBox.Show("DBANZXŗO܂B")
        Finally
            If Not (oConn Is Nothing) Then
                oConn.Close()
            End If
        End Try

    End Sub

    ''' <summary>
    ''' DBXPW[ǂݍ
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub LoadScheduleData()
        Const strSelectSchedule As String = "SELECT * FROM Schedules"
        Const strSelectMemo As String = "SELECT * FROM Memos"

        Dim oConn As New OleDbConnection()
        Dim oCommandSchedule, oCommandMemo As New OleDbCommand()
        Dim oReaderSchedule, oReaderMemo As OleDbDataReader

        Try
            oConn = New OleDbConnection()
            oConn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & _
            Application.StartupPath + "\Scheduler.mdb"
            oCommandSchedule.Connection = oConn

            'caڑJ
            oConn.Open()

            'SQL̐ݒ
            oCommandSchedule.CommandText = strSelectSchedule
            oReaderSchedule = oCommandSchedule.ExecuteReader()

            m_scheduleDataList.Clear()

            Dim scheduleData As New ScheduleDataClass
            While oReaderSchedule.Read()

                scheduleData.StartDateTime = oReaderSchedule.Item("StartDateTime")
                scheduleData.EndDateTime = oReaderSchedule.Item("EndDateTime")
                scheduleData.InputDateTime = oReaderSchedule.Item("InputDateTime")
                scheduleData.Title = oReaderSchedule.Item("Title")

                scheduleData.Place = oReaderSchedule.Item("Place")
                scheduleData.Memo = oReaderSchedule.Item("MemoData")
                scheduleData.RepeatStartDateTime = oReaderSchedule.Item("RepeatStartDate")
                scheduleData.RepeatEndDateTime = oReaderSchedule.Item("RepeatEndDate")
                scheduleData.RepeatType = oReaderSchedule.Item("RepeatType")
                scheduleData.Valid = oReaderSchedule.Item("ValidData")

                m_scheduleDataList.Add(New ScheduleDataClass(scheduleData))
            End While

            'ǂݍ
            oCommandMemo.Connection = oConn
            oCommandMemo.CommandText = strSelectMemo
            oReaderMemo = oCommandMemo.ExecuteReader()

            m_memos.Clear()
            Dim memoData As New MemoDataClass
            While oReaderMemo.Read()
                memoData.DateOfThis = oReaderMemo.Item("DateData")
                memoData.Text = oReaderMemo.Item("MemoData")

                m_memos.Add(New MemoDataClass(memoData))
            End While

            'eɃf[^WJ
            m_scheduleDataList.Sort()

        Catch oExcept As Exception
            MessageBox.Show("DBANZXŗO܂B")
        Finally
            If Not (oConn Is Nothing) Then
                oConn.Close()
            End If
        End Try

    End Sub

    ''' <summary>
    ''' ǎɖ߂
    ''' </summary>
    ''' <param name="originalWallPaperName"></param>
    ''' <remarks></remarks>
    Public Sub BringBackWallPaper(ByRef originalWallPaperName As String)
        Dim paperPath As String
        Dim paperName As String = "myschedule"

        paperPath = Application.StartupPath & "\" + paperName & ".bmp"
        Dim desktopImage As New DeskWallpaper

        If desktopImage.CurrentWallpaperPath.Equals(paperPath) Then
            If Not originalWallPaperName.Equals("") Then
                desktopImage.SetDesktopImage(originalWallPaperName)
                originalWallPaperName = ""
            End If
        End If
    End Sub


    ''' <summary>
    ''' ǎɃJ_[`
    ''' </summary>
    ''' <param name="originalWallPaperName"></param>
    ''' <remarks></remarks>
    Public Sub DrawScheduleCalendarToWallPaper(ByRef originalWallPaperName As String)
        Dim bmpCalendar As New Bitmap(640, 480)
        Dim g As Graphics = Graphics.FromImage(bmpCalendar)
        Dim replacedPaperPath As String
        Dim paperName As String = "myschedule"
        Dim paperPath As String
        Dim errorstr As String = ""

        Dim marginX As Integer = 45
        Dim marginY As Integer = 30

        '`
        DrawSchedulesForImage(g, New Rectangle(marginX, marginY, bmpCalendar.Width - marginX * 2, bmpCalendar.Height - marginY * 2), New Font("MS UI Gothic", 9), True, New Rectangle(0, 0, bmpCalendar.Width, bmpCalendar.Height))

        'KvłΕǎ߂
        BringBackWallPaper(originalWallPaperName)

        'J_[ǎZbg
        Dim wallpaper As New WallpaperImageMap(bmpCalendar)
        replacedPaperPath = wallpaper.SetDeskWallpaperImage(paperName, 60, errorstr)
        paperPath = Application.StartupPath & "\" + paperName & ".bmp"

        If Not replacedPaperPath.Equals(paperPath) Then
            originalWallPaperName = replacedPaperPath
        End If

        If Not errorstr.Equals("") Then
            MessageBox.Show(errorstr, "Scheduler", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If
    End Sub

    ''' <summary>
    ''' XPW[̕ҏW
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub EditScheduleToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EditScheduleToolStripMenuItem.Click
        EditSchedule()
    End Sub

    ''' <summary>
    ''' XPW[̍폜
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub DelScheduleToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DelScheduleToolStripMenuItem.Click
        DeleteSchedule()
    End Sub

    ''' <summary>
    ''' XPW[̒ǉ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub AddScheduleToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddScheduleToolStripMenuItem.Click
        AddSchedule()
    End Sub

    ''' <summary>
    ''' ̓tɔőI
    ''' </summary>
    ''' <param name="sd"></param>
    ''' <remarks></remarks>
    Public Sub SelectDate(ByVal sd As DateTime)

        Dim nextMonth, prevMonth As New DateTime
        Dim i As Integer

        m_showingMonth = New DateTime(sd.Year, sd.Month, 1)

        nextMonth = m_showingMonth.AddMonths(1)
        prevMonth = m_showingMonth.AddMonths(-1)

        CreateDaysData()

        If System.IO.File.Exists(configData.ImagePath(m_showingMonth.Month)) Then
            Try
                SplitContainerImage.Panel1.BackgroundImage = Image.FromFile(configData.ImagePath(m_showingMonth.Month))
            Catch ex As Exception
                SplitContainerImage.Panel1.BackgroundImage = Nothing
            End Try
        Else
            SplitContainerImage.Panel1.BackgroundImage = Nothing
        End If

        'eɃf[^WJ
        ArrageSchedulesToDayData()

        'J_[{^Abvf[g
        PrevMonthCalendarButton.CurrentDate = m_showingMonth.AddMonths(-1)
        NextMonthCalendarButton.CurrentDate = m_showingMonth.AddMonths(1)

        For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
            If sd.Equals(m_showingMonthDays(i).DateOfThis) Then
                m_showingMonthDays(i).CheckSelectDate(0, 0, PanelCalendar, True)
            End If
        Next

        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            If sd.Equals(m_nextMonthDays(i).DateOfThis) Then
                m_nextMonthDays(i).CheckSelectDate(0, 0, PanelCalendar, True)
            End If
        Next

        For i = DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month) To 1 Step -1
            If sd.Equals(m_prevMonthDays(i).DateOfThis) Then
                m_prevMonthDays(i).CheckSelectDate(0, 0, PanelCalendar, True)
            End If
        Next

        Refresh()
        SendUpdateDataEvent()
        SendUpdateDayDataEvent()
    End Sub

    ''' <summary>
    ''' PƂ̃Xgr[ɃXPW[\
    ''' </summary>
    ''' <param name="lv"></param>
    ''' <param name="schedulesAdded"></param>
    ''' <remarks></remarks>
    Public Sub WriteDaySchedulesToListView(ByRef lv As ListView, ByRef schedulesAdded As List(Of ScheduleDataClass))
        Dim i As Integer
        Dim nextMonth, prevMonth As New DateTime

        nextMonth = m_showingMonth.AddMonths(1)
        prevMonth = m_showingMonth.AddMonths(-1)

        For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
            ''Xgr[XV
            If ShowingMonthDays(i).Selected Then
                ShowingMonthDays(i).WriteDaySchedulesToListView(lv, schedulesAdded)
                Exit Sub
            End If
        Next

        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            ''Xgr[XV
            If NextMonthDays(i).Selected Then
                NextMonthDays(i).WriteDaySchedulesToListView(lv, schedulesAdded)
                Exit Sub
            End If
        Next

        For i = DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month) To 1 Step -1
            ''Xgr[XV
            If PrevMonthDays(i).Selected Then
                PrevMonthDays(i).WriteDaySchedulesToListView(lv, schedulesAdded)
                Exit Sub
            End If
        Next

    End Sub

    ''' <summary>
    ''' eLXg{bNXɃ\
    ''' </summary>
    ''' <param name="tb"></param>
    ''' <param name="pn"></param>
    ''' <remarks></remarks>
    Public Sub WriteMemoToTextBox(ByRef tb As TextBox, ByRef pn As Panel)
        Dim i As Integer
        Dim nextMonth, prevMonth As New DateTime

        nextMonth = m_showingMonth.AddMonths(1)
        prevMonth = m_showingMonth.AddMonths(-1)

        For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
            If ShowingMonthDays(i).Selected Then
                If ShowingMonthDays(i).Memo.Text <> "" Then
                    tb.Text = ShowingMonthDays(i).Memo.Text
                End If
                pn.Refresh()
                Exit Sub
            End If
        Next

        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            If NextMonthDays(i).Selected Then
                If NextMonthDays(i).Memo.Text <> "" Then
                    tb.Text = NextMonthDays(i).Memo.Text
                End If
                pn.Refresh()
                Exit Sub
            End If
        Next

        For i = DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month) To 1 Step -1
            If PrevMonthDays(i).Selected Then
                If PrevMonthDays(i).Memo.Text <> "" Then
                    tb.Text = PrevMonthDays(i).Memo.Text
                End If
                pn.Refresh()
                Exit Sub
            End If
        Next

    End Sub

    ''' <summary>
    ''' eɂƂɕۑ
    ''' </summary>
    ''' <param name="str"></param>
    ''' <remarks></remarks>
    Public Sub StoreMemoToMemory(ByVal str As String)
        Dim i As Integer
        Dim nextMonth, prevMonth As New DateTime

        nextMonth = m_showingMonth.AddMonths(1)
        prevMonth = m_showingMonth.AddMonths(-1)

        For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
            If ShowingMonthDays(i).Selected Then
                If str = "" Or ShowingMonthDays(i).Memo.Text = "" Then
                    ShowingMonthDays(i).IsDisplayMemoIcon = True
                Else
                    ShowingMonthDays(i).IsDisplayMemoIcon = False
                End If

                ShowingMonthDays(i).Memo.Text = str
                ShowingMonthDays(i).Memo.DateOfThis = ShowingMonthDays(i).DateOfThis
                Exit Sub
            End If
        Next

        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            If NextMonthDays(i).Selected Then
                If str = "" Or NextMonthDays(i).Memo.Text = "" Then
                    NextMonthDays(i).IsDisplayMemoIcon = True
                Else
                    NextMonthDays(i).IsDisplayMemoIcon = False
                End If

                NextMonthDays(i).Memo.Text = str
                NextMonthDays(i).Memo.DateOfThis = NextMonthDays(i).DateOfThis
                Exit Sub
            End If
        Next

        For i = DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month) To 1 Step -1
            If PrevMonthDays(i).Selected Then
                If str = "" Or PrevMonthDays(i).Memo.Text = "" Then
                    PrevMonthDays(i).IsDisplayMemoIcon = True
                Else
                    PrevMonthDays(i).IsDisplayMemoIcon = False
                End If

                PrevMonthDays(i).Memo.Text = str
                PrevMonthDays(i).Memo.DateOfThis = PrevMonthDays(i).DateOfThis
                Exit Sub
            End If
        Next

    End Sub

    ''' <summary>
    ''' f[^ɓo^
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub RegisterMemoToMemory()
        Dim i As Integer
        Dim nextMonth, prevMonth As New DateTime

        nextMonth = m_showingMonth.AddMonths(1)
        prevMonth = m_showingMonth.AddMonths(-1)

        For i = 1 To DateTime.DaysInMonth(m_showingMonth.Year, m_showingMonth.Month)
            If ShowingMonthDays(i).Memo.Text <> "" Then
                If ShowingMonthDays(i).Memo.BaseMemo Is Nothing Then
                    'ǉ
                    m_memos.Add(New MemoDataClass(ShowingMonthDays(i).DateOfThis, ShowingMonthDays(i).Memo.Text))
                    ShowingMonthDays(i).Memo.BaseMemo = m_memos(m_memos.Count - 1)
                Else
                    'ύX
                    ShowingMonthDays(i).Memo.BaseMemo.Copy(ShowingMonthDays(i).Memo)
                End If
            Else
                If ShowingMonthDays(i).Memo.BaseMemo IsNot Nothing Then
                    '폜
                    ShowingMonthDays(i).Memo.BaseMemo.Copy(ShowingMonthDays(i).Memo)
                    ShowingMonthDays(i).Memo.BaseMemo.IsValid = False
                End If
            End If
        Next

        For i = 1 To DateTime.DaysInMonth(nextMonth.Year, nextMonth.Month)
            If NextMonthDays(i).Memo.Text <> "" Then
                If NextMonthDays(i).Memo.BaseMemo Is Nothing Then
                    m_memos.Add(New MemoDataClass(NextMonthDays(i).DateOfThis, NextMonthDays(i).Memo.Text))
                    NextMonthDays(i).Memo.BaseMemo = m_memos(m_memos.Count - 1)
                Else
                    NextMonthDays(i).Memo.BaseMemo.Copy(NextMonthDays(i).Memo)
                End If
            Else
                If NextMonthDays(i).Memo.BaseMemo IsNot Nothing Then
                    '폜
                    NextMonthDays(i).Memo.BaseMemo.Copy(NextMonthDays(i).Memo)
                    NextMonthDays(i).Memo.BaseMemo.IsValid = False
                End If
            End If
        Next

        For i = DateTime.DaysInMonth(prevMonth.Year, prevMonth.Month) To 1 Step -1
            If PrevMonthDays(i).Memo.Text <> "" Then
                If PrevMonthDays(i).Memo.BaseMemo Is Nothing Then
                    m_memos.Add(New MemoDataClass(PrevMonthDays(i).DateOfThis, PrevMonthDays(i).Memo.Text))
                    PrevMonthDays(i).Memo.BaseMemo = m_memos(m_memos.Count - 1)
                Else
                    PrevMonthDays(i).Memo.BaseMemo.Copy(PrevMonthDays(i).Memo)
                End If
            Else
                If PrevMonthDays(i).Memo.BaseMemo IsNot Nothing Then
                    '폜
                    PrevMonthDays(i).Memo.BaseMemo.Copy(PrevMonthDays(i).Memo)
                    PrevMonthDays(i).Memo.BaseMemo.IsValid = False
                End If
            End If
        Next

    End Sub

    ''' <summary>
    ''' ReLXgj[JƂɍڂ𐧌
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ContextMenuStrip1_Opening(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles ContextMenuStrip1.Opening
        If EditSchedule(False) Then 'XPW[IĂĕҏWł邩`FbN
            EditScheduleToolStripMenuItem.Enabled = True
            DelScheduleToolStripMenuItem.Enabled = True
        Else
            EditScheduleToolStripMenuItem.Enabled = False
            DelScheduleToolStripMenuItem.Enabled = False
        End If
    End Sub

End Class
