Public Class EditScheduleForm

    Private m_repeatType As ScheduleDataClass.RepeatTypePattern = ScheduleDataClass.RepeatTypePattern.None
    Private m_startDateTime, m_endDateTime As DateTime

    'JԂ̎
    Public Property RepeatType() As ScheduleDataClass.RepeatTypePattern
        Get
            Return m_repeatType
        End Get
        Set(ByVal value As ScheduleDataClass.RepeatTypePattern)
            m_repeatType = value
        End Set
    End Property

    'XPW[̊Jn
    Public Property StartDateTime() As DateTime
        Get
            Return m_startDateTime
        End Get
        Set(ByVal value As DateTime)
            m_startDateTime = value
        End Set
    End Property

    'XPW[̏I
    Public Property EndDateTime() As DateTime
        Get
            Return m_endDateTime
        End Get
        Set(ByVal value As DateTime)
            m_endDateTime = value
        End Set
    End Property


    ''' <summary>
    ''' tH[[h
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub EditScheduleForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Select Case m_repeatType
            Case ScheduleDataClass.RepeatTypePattern.None
                RepeatNoneRadioButton.Checked = True
            Case ScheduleDataClass.RepeatTypePattern.daily
                RepeatDailyRadioButton.Checked = True
            Case ScheduleDataClass.RepeatTypePattern.weekly
                RepeatWeeklyRadioButton.Checked = True
            Case ScheduleDataClass.RepeatTypePattern.monthly
                RepeatMonthlyRadioButton.Checked = True
        End Select

        m_startDateTime = Nothing
        m_endDateTime = Nothing

        CheckScheduleRange()
    End Sub


    ''' <summary>
    ''' tH[I@G[`FbN
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub EditScheduleForm_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Dim startDateStr, endDateStr As String

        If Me.DialogResult = Windows.Forms.DialogResult.OK Then

            'JnAI̓tƎԂ̓
            Try
                startDateStr = StartDateTimePicker.Value.ToShortDateString.ToString & " " & _
                               StartTimeComboBox.Text.ToString
                endDateStr = EndDateTimePicker.Value.ToShortDateString.ToString & " " & _
                               EndTimeComboBox.Text.ToString
                m_startDateTime = DateTime.ParseExact(startDateStr, "yyyy/M/d H:m", Nothing)
                m_endDateTime = DateTime.ParseExact(endDateStr, "yyyy/M/d H:m", Nothing)

            Catch ex As Exception
                startDateStr = StartDateTimePicker.Value.ToShortDateString.ToString & " " & _
                               "00:00"
                endDateStr = EndDateTimePicker.Value.ToShortDateString.ToString & " " & _
                               "00:00"
                m_startDateTime = DateTime.ParseExact(startDateStr, "yyyy/M/d H:m", Nothing)
                m_endDateTime = DateTime.ParseExact(endDateStr, "yyyy/M/d H:m", Nothing)

            End Try

            '̓`FbN
            If TitleTextBox.Text = "" Then
                ErrorLabel.Text = "^Cg͕K͂ĂB"
                TitleTextBox.Focus()
                e.Cancel = True
            ElseIf m_startDateTime > m_endDateTime Then
                ErrorLabel.Text = "Jn͏IOɂĂB"
                StartDateTimePicker.Focus()
                e.Cancel = True
            ElseIf (m_repeatType <> ScheduleDataClass.RepeatTypePattern.None) And (m_endDateTime > RepeatEndDateTimePicker.Value.Date) Then
                ErrorLabel.Text = "JԂ̏ÍAXPW[̏IɂĂB"
                RepeatEndDateTimePicker.Focus()
                e.Cancel = True
            End If

        End If
    End Sub


    ''' <summary>
    ''' OK{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click

    End Sub

    ''' <summary>
    ''' LZ{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click

    End Sub

    ''' <summary>
    ''' JԂWI{^̒lۑ
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub SaveRadioButtonValue()
        If RepeatNoneRadioButton.Checked Then
            RepeatEndDateTimePicker.Enabled = False
        Else
            RepeatEndDateTimePicker.Enabled = True
        End If

        If RepeatNoneRadioButton.Checked Then
            m_repeatType = ScheduleDataClass.RepeatTypePattern.None
        ElseIf RepeatDailyRadioButton.Checked Then
            m_repeatType = ScheduleDataClass.RepeatTypePattern.daily
        ElseIf RepeatWeeklyRadioButton.Checked Then
            m_repeatType = ScheduleDataClass.RepeatTypePattern.weekly
        ElseIf RepeatMonthlyRadioButton.Checked Then
            m_repeatType = ScheduleDataClass.RepeatTypePattern.monthly
        End If
    End Sub

    ''' <summary>
    ''' JԂWI{^̑IڂςƂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub RepeatRadioButton_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
        Handles RepeatNoneRadioButton.CheckedChanged, RepeatDailyRadioButton.CheckedChanged, RepeatWeeklyRadioButton.CheckedChanged, RepeatMonthlyRadioButton.CheckedChanged

        SaveRadioButtonValue()
    End Sub


    ''' <summary>
    ''' XPW[̒ɂČJԂł邩ǂ𔻒f
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub CheckScheduleRange()
        Try
            Dim span As TimeSpan = EndDateTimePicker.Value.Date - StartDateTimePicker.Value.Date

            RepeatDailyRadioButton.Enabled = True
            RepeatWeeklyRadioButton.Enabled = True
            RepeatMonthlyRadioButton.Enabled = True

            If span.Days >= 28 Then
                RepeatMonthlyRadioButton.Checked = False
                RepeatMonthlyRadioButton.Enabled = False
            End If

            If span.Days >= 7 Then
                RepeatWeeklyRadioButton.Checked = False
                RepeatWeeklyRadioButton.Enabled = False
            End If

            If span.Days >= 1 Then
                RepeatDailyRadioButton.Checked = False
                RepeatDailyRadioButton.Enabled = False
            End If

        Catch ex As Exception
            RepeatDailyRadioButton.Enabled = True
            RepeatWeeklyRadioButton.Enabled = True
            RepeatMonthlyRadioButton.Enabled = True
        End Try

        'IĂȂΌJԂȂ
        If RepeatMonthlyRadioButton.Checked = False And RepeatWeeklyRadioButton.Checked = False And _
           RepeatDailyRadioButton.Checked = False Then
            RepeatNoneRadioButton.Checked = True
        End If

        SaveRadioButtonValue()

        Select Case m_repeatType
            Case ScheduleDataClass.RepeatTypePattern.None
                RepeatNoneRadioButton.Checked = True
            Case ScheduleDataClass.RepeatTypePattern.daily
                RepeatDailyRadioButton.Checked = True
            Case ScheduleDataClass.RepeatTypePattern.weekly
                RepeatWeeklyRadioButton.Checked = True
            Case ScheduleDataClass.RepeatTypePattern.monthly
                RepeatMonthlyRadioButton.Checked = True
        End Select

    End Sub

    ''' <summary>
    ''' JnςƂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub StartDateTimePicker_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles StartDateTimePicker.ValueChanged
        CheckScheduleRange()
    End Sub

    ''' <summary>
    ''' IςƂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub EndDateTimePicker_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles EndDateTimePicker.ValueChanged
        CheckScheduleRange()
    End Sub
End Class