Imports System.Drawing.Drawing2D
Imports System.Windows.Forms
Imports System.ComponentModel

<DefaultEvent("Click")> _
Public Class GraphicalButtonCtrl
    Implements IButtonControl

    Private componentContainer As System.ComponentModel.Container = Nothing
    Private m_DialogResult As DialogResult
    Protected m_DrawState As DrawState = DrawState.Normal
    Private m_topColor As Color = Color.Blue
    Private m_bottomColor As Color = Color.DarkBlue
    Private m_borderColor As Color = Color.Black
    Private m_textAlign As ContentAlignment = ContentAlignment.MiddleCenter
    Private m_colorFillMode As ButtonFillMode = ButtonFillMode.Translucent
    Private m_drawBorder As Boolean = True
    Private m_drawLabel As Boolean = True
    Private m_alphaValue As Integer = 100

    Protected Enum DrawState
        Normal
        Hover
        Pressed
    End Enum

    Public Enum ButtonFillMode
        Gradation
        Translucent
    End Enum

    '㑤̐F
    Public Property TopColor() As Color
        Get
            Return m_topColor
        End Get
        Set(ByVal value As Color)
            m_topColor = value
            Me.Refresh()
        End Set
    End Property

    '̐F
    Public Property BottomColor() As Color
        Get
            Return m_bottomColor
        End Get
        Set(ByVal value As Color)
            m_bottomColor = value
            Me.Refresh()
        End Set
    End Property

    'g̐F
    Public Property BorderColor() As Color
        Get
            Return m_borderColor
        End Get
        Set(ByVal value As Color)
            m_borderColor = value
            Me.Refresh()
        End Set
    End Property

    'eLXgʒu
    Public Property TextAlign() As ContentAlignment
        Get
            Return m_textAlign
        End Get
        Set(ByVal value As ContentAlignment)
            m_textAlign = value
            Me.Refresh()
        End Set
    End Property

    'Of[V
    Public Property ColorFillMode() As ButtonFillMode
        Get
            Return m_colorFillMode
        End Get
        Set(ByVal value As ButtonFillMode)
            m_colorFillMode = value
            Me.Refresh()
        End Set
    End Property

    'g`悷邩ǂ
    Public Property DrawBorder() As Boolean
        Get
            Return m_drawBorder
        End Get
        Set(ByVal value As Boolean)
            m_drawBorder = value
            Me.Refresh()
        End Set
    End Property

    'x`悷邩ǂ
    Public Property DrawLabel() As Boolean
        Get
            Return m_drawLabel
        End Get
        Set(ByVal value As Boolean)
            m_drawLabel = value
            Me.Refresh()
        End Set
    End Property

    '̃At@l
    Public Property AlphaValue() As Integer
        Get
            Return m_alphaValue
        End Get
        Set(ByVal value As Integer)
            m_alphaValue = value
            Me.Refresh()
        End Set
    End Property

    ''' <summary>
    ''' RXgN^
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub New()
        ' ̌ĂяóAWindows tH[ fUCiŕKvłB
        InitializeComponent()

        ' InitializeComponent() Ăяǒŏǉ܂B

        Me.ResizeRedraw = True
        Me.SetStyle(ControlStyles.DoubleBuffer, True)
        Me.SetStyle(ControlStyles.UserPaint, True)
        Me.SetStyle(ControlStyles.SupportsTransparentBackColor, True)
        Me.BackColor = Color.Transparent
    End Sub

    ''' <summary>
    ''' IButtonControl.DialogResult
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property DialogResult() As DialogResult Implements IButtonControl.DialogResult
        Get
            Return Me.m_DialogResult
        End Get

        Set(ByVal value As DialogResult)
            If [Enum].IsDefined(GetType(DialogResult), value) Then
                Me.m_DialogResult = value
            End If
        End Set
    End Property

    ''' <summary>
    ''' IButtonControl.NotifyDefault
    ''' </summary>
    ''' <param name="value"></param>
    ''' <remarks></remarks>
    Public Sub NotifyDefault(ByVal value As Boolean) Implements IButtonControl.NotifyDefault
    End Sub

    ''' <summary>
    ''' IButtonControl.PerformClick
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub PerformClick() Implements IButtonControl.PerformClick
        If Me.Enabled Then
            Me.OnClick(EventArgs.Empty)
        End If
    End Sub

    ''' <summary>
    ''' `Cxgnh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub GraphicalButtonCtrl_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint

    End Sub

    ''' <summary>
    ''' {^̕`
    ''' </summary>
    ''' <param name="g"></param>
    ''' <param name="mypen"></param>
    ''' <param name="backBrush"></param>
    ''' <param name="rect"></param>
    ''' <param name="sizeinfo"></param>
    ''' <remarks></remarks>
    Private Sub FillRoundedRectangle(ByVal g As Graphics, ByVal mypen As Pen, ByVal backBrush As Brush, ByVal rect As Rectangle, ByVal sizeinfo As Size)

        Dim sm As SmoothingMode = g.SmoothingMode
        Dim pom As PixelOffsetMode = g.PixelOffsetMode
        g.SmoothingMode = SmoothingMode.AntiAlias
        g.PixelOffsetMode = System.Drawing.Drawing2D.PixelOffsetMode.HighQuality

        Dim graphicPath As GraphicsPath = New GraphicsPath()
        graphicPath.FillMode = FillMode.Winding
        graphicPath.AddArc(rect.Right - sizeinfo.Width, rect.Top, sizeinfo.Width, sizeinfo.Height, 270, 90)
        graphicPath.AddArc(rect.Right - sizeinfo.Width, rect.Bottom - sizeinfo.Height, sizeinfo.Width, sizeinfo.Height, 0, 90)
        graphicPath.AddArc(rect.Left, rect.Bottom - sizeinfo.Height, sizeinfo.Width, sizeinfo.Height, 90, 90)
        graphicPath.AddArc(rect.Left, rect.Top, sizeinfo.Width, sizeinfo.Height, 180, 90)
        graphicPath.AddArc(rect.Right - sizeinfo.Width, rect.Top, sizeinfo.Width, sizeinfo.Height, 270, 90)
        g.FillPath(backBrush, graphicPath)

        g.SmoothingMode = sm
        g.PixelOffsetMode = pom
    End Sub

    ''' <summary>
    ''' x̕`
    ''' </summary>
    ''' <param name="g"></param>
    ''' <param name="strText"></param>
    ''' <param name="ForeBrush"></param>
    ''' <param name="rect"></param>
    ''' <param name="sizeinfo"></param>
    ''' <param name="ca"></param>
    ''' <remarks></remarks>
    Private Sub RoundedRectangleString(ByVal g As Graphics, ByVal strText As String, ByVal ForeBrush As Brush, ByVal rect As Rectangle, ByVal sizeinfo As Size, ByVal ca As ContentAlignment)
        If strText IsNot Nothing And strText.Length > 0 Then
            Dim trh As System.Drawing.Text.TextRenderingHint = g.TextRenderingHint
            g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias
            Dim myStringFormat As StringFormat = GetStringFormat(ca)

            g.DrawString(strText, Me.Font, ForeBrush, New Rectangle(rect.Left + sizeinfo.Width / 4, rect.Top + sizeinfo.Height / 4, rect.Width - sizeinfo.Width / 2, rect.Height - sizeinfo.Height / 2), myStringFormat)
            g.TextRenderingHint = trh

        End If
    End Sub

    ''' <summary>
    ''' x̕`
    ''' </summary>
    ''' <param name="g"></param>
    ''' <param name="strText"></param>
    ''' <param name="ForeBrush"></param>
    ''' <param name="rect"></param>
    ''' <param name="ca"></param>
    ''' <remarks></remarks>
    Private Sub DrawRectangleString(ByVal g As Graphics, ByVal strText As String, ByVal ForeBrush As Brush, ByVal rect As Rectangle, ByVal ca As ContentAlignment)
        If strText IsNot Nothing And strText.Length > 0 Then
            Dim trh As System.Drawing.Text.TextRenderingHint = g.TextRenderingHint
            g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias
            Dim myStringFormat As StringFormat = GetStringFormat(ca)

            g.DrawString(strText, Me.Font, ForeBrush, New Rectangle(rect.Left, rect.Top, rect.Width, rect.Height), myStringFormat)
            g.TextRenderingHint = trh

        End If
    End Sub


    ''' <summary>
    ''' ̃tH[}bgԂ
    ''' </summary>
    ''' <param name="ca"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function GetStringFormat(ByVal ca As ContentAlignment) As StringFormat

        Dim myStringFormat As StringFormat = New StringFormat()

        Select Case ca
            Case ContentAlignment.BottomCenter
                myStringFormat.Alignment = StringAlignment.Center
                myStringFormat.LineAlignment = StringAlignment.Far
            Case ContentAlignment.BottomLeft
                myStringFormat.Alignment = StringAlignment.Near
                myStringFormat.LineAlignment = StringAlignment.Far
            Case ContentAlignment.BottomRight
                myStringFormat.Alignment = StringAlignment.Far
                myStringFormat.LineAlignment = StringAlignment.Far
            Case ContentAlignment.MiddleCenter
                myStringFormat.Alignment = StringAlignment.Center
                myStringFormat.LineAlignment = StringAlignment.Center
            Case ContentAlignment.MiddleLeft
                myStringFormat.Alignment = StringAlignment.Near
                myStringFormat.LineAlignment = StringAlignment.Center
            Case ContentAlignment.MiddleRight
                myStringFormat.Alignment = StringAlignment.Far
                myStringFormat.LineAlignment = StringAlignment.Center
            Case ContentAlignment.TopCenter
                myStringFormat.Alignment = StringAlignment.Center
                myStringFormat.LineAlignment = StringAlignment.Near
            Case ContentAlignment.TopLeft
                myStringFormat.Alignment = StringAlignment.Near
                myStringFormat.LineAlignment = StringAlignment.Near
            Case ContentAlignment.TopRight
                myStringFormat.Alignment = StringAlignment.Far
                myStringFormat.LineAlignment = StringAlignment.Near

        End Select

        GetStringFormat = myStringFormat
    End Function

    ''' <summary>
    ''' ݒFx[XɈÂFԂ
    ''' </summary>
    ''' <param name="c"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function GetDarkColor(ByVal c As Color) As Color
        Dim iDark As Integer = 80
        Dim iR As Integer
        Dim iG As Integer
        Dim iB As Integer

        If (c.R > iDark) Then
            iR = c.R - iDark
        Else
            iR = 0
        End If

        If (c.G > iDark) Then
            iG = c.G - iDark
        Else
            iG = 0
        End If

        If (c.B > iDark) Then
            iB = c.B - iDark
        Else
            iB = 0
        End If

        GetDarkColor = Color.FromArgb(iR, iG, iB)
    End Function

    ''' <summary>
    ''' ݒFx[Xɖ邢FԂ
    ''' </summary>
    ''' <param name="c"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function GetLightColor(ByVal c As Color) As Color
        Dim iLight As Integer = 40
        Dim iR As Integer
        Dim iG As Integer
        Dim iB As Integer

        If (c.R < 255 - iLight) Then
            iR = c.R + iLight
        Else
            iR = 255
        End If


        If (c.G < 255 - iLight) Then
            iG = c.G + iLight
        Else
            iG = 255
        End If

        If (c.B < 255 - iLight) Then
            iB = c.B + iLight
        Else
            iB = 255
        End If

        GetLightColor = Color.FromArgb(iR, iG, iB)
    End Function


    ''' <summary>
    ''' `惂[hɂuVԂ
    ''' </summary>
    ''' <param name="rc"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function GetBrushForDrawState(ByVal rc As Rectangle) As Brush
        Dim color1 As Color = Me.TopColor
        Dim color2 As Color = Me.BottomColor
        Select Case Me.m_DrawState
            Case DrawState.Normal
                color1 = Me.TopColor
                color2 = Me.BottomColor
            Case DrawState.Hover
                color1 = GetLightColor(Me.TopColor)
                color2 = GetLightColor(Me.BottomColor)
            Case DrawState.Pressed
                color1 = Me.BottomColor
                color2 = Me.TopColor
        End Select

        If m_colorFillMode = ButtonFillMode.Gradation Then
            GetBrushForDrawState = New LinearGradientBrush(rc, color1, color2, LinearGradientMode.Vertical)
        ElseIf m_colorFillMode = ButtonFillMode.Translucent Then
            GetBrushForDrawState = New SolidBrush(Color.FromArgb(m_alphaValue, color1.R, color1.G, color1.B))
        Else
            GetBrushForDrawState = New SolidBrush(Color.White)
        End If

    End Function

    ''' <summary>
    ''' Oʕ`puVԂ
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function GetForeBrushForDrawState() As Brush
        Dim color1 As Color = Me.ForeColor
        If Me.m_DrawState = DrawState.Pressed Then
            color1 = GetDarkColor(Me.ForeColor)
        End If
        If Me.Enabled = False Then
            color1 = GetDarkColor(Me.TopColor)
        End If
        GetForeBrushForDrawState = New SolidBrush(color1)
    End Function


    ''' <summary>
    ''' `Cxgnh
    ''' </summary>
    ''' <param name="pevent"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnPaint(ByVal pevent As PaintEventArgs)
        Dim foreBrush As Brush = GetForeBrushForDrawState()

        Dim rc As New Rectangle(0, 0, Me.ClientRectangle.Width, Me.ClientRectangle.Height)
        Dim backBrush As Brush = GetBrushForDrawState(rc)
        pevent.Graphics.FillRectangle(backBrush, rc)
        Dim rectPen As Pen = New Pen(m_borderColor, 1)

        If m_drawBorder Then
            rc.Width -= 1
            rc.Height -= 1
            pevent.Graphics.DrawRectangle(rectPen, rc)
        End If

        If m_drawLabel Then
            DrawRectangleString(pevent.Graphics, Me.Text, foreBrush, rc, TextAlign)
        End If
    End Sub

    ''' <summary>
    ''' `惂[h̐ݒ
    ''' </summary>
    ''' <param name="drawState"></param>
    ''' <remarks></remarks>
    Private Sub SetDrawState(ByVal drawState As DrawState)
        If Me.m_DrawState <> drawState Then
            Me.m_DrawState = drawState
            Me.Refresh()
        End If
    End Sub

    ''' <summary>
    ''' }EX̃{^ꂽƂ̃Cxgnh
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnMouseDown(ByVal e As MouseEventArgs)
        If e.Button = System.Windows.Forms.MouseButtons.Left Then
            SetDrawState(DrawState.Pressed)
            Me.Capture = True
            Me.Focus()
        End If

        MyBase.OnMouseDown(e)
    End Sub

    ''' <summary>
    ''' }EXJ[\ɂƂ̃Cxgnh
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnMouseEnter(ByVal e As EventArgs)
        SetDrawState(DrawState.Hover)
        MyBase.OnMouseEnter(e)
    End Sub

    ''' <summary>
    ''' }EXJ[\ɂƂ̃Cxgnh
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnMouseHover(ByVal e As EventArgs)
        MyBase.OnMouseHover(e)
    End Sub

    ''' <summary>
    ''' }EXJ[\ɂȂȂƂ̃Cxgnh
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnMouseLeave(ByVal e As EventArgs)
        If Me.Enabled = True Then
            SetDrawState(DrawState.Normal)
        End If
        MyBase.OnMouseLeave(e)
    End Sub

    ''' <summary>
    ''' }EXړƂ̃Cxgnh
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnMouseMove(ByVal e As MouseEventArgs)
        If e.Button = System.Windows.Forms.MouseButtons.Left Then
            If e.X > 0 And e.Y > 0 And e.X < Me.Width And e.Y < Me.Height Then
                SetDrawState(DrawState.Pressed)
            Else
                SetDrawState(DrawState.Normal)
            End If
        End If
        MyBase.OnMouseMove(e)
    End Sub

    ''' <summary>
    ''' NbÑCxgnh
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnClick(ByVal e As EventArgs)

    End Sub

    ''' <summary>
    ''' }EX{^オƂ̃Cxgnh
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnMouseUp(ByVal e As MouseEventArgs)

        If e.Button = System.Windows.Forms.MouseButtons.Left Then
            Me.Capture = False

            If Me.Enabled Then
                MyBase.OnClick(EventArgs.Empty)
            End If

            SetDrawState(DrawState.Normal)
        End If

        MyBase.OnMouseUp(e)
    End Sub

    <Browsable(True), DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)> _
    Public Overrides Property Text() As String
        Get
            Return MyBase.Text
        End Get
        Set(ByVal value As String)
            MyBase.Text = value
            Me.Invalidate()
        End Set
    End Property

End Class
